/*
 * MP3/MPlayer plugin to VDR (C++)
 *
 * (C) 2001-2005 Stefan Huelswitt <s.huelswitt@gmx.de>
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 */

#ifndef ___STREAM_H
#define ___STREAM_H

#include "decoder.h"


// ----------------------------------------------------------------

class cStream:public cFileInfo
{
  private:
    int fd;
    bool ismmap;
  protected:
    unsigned char *buffer;
    unsigned long long readpos, buffpos;
    unsigned long fill;
  public:
      cStream( const char *Filename );
      virtual ~ cStream(  );
    virtual bool Open( bool log = true );
    virtual void Close( void );
    virtual bool Stream( unsigned char *&data, unsigned long &len, const unsigned char *rest = NULL );
    virtual bool Seek( unsigned long long pos = 0 );
    virtual unsigned long long BufferPos( void )
    {
        return buffpos;
    }
};

#endif //___STREAM_H
